]> code.delx.au - transcoding/blobdiff - fix-pal-speedup
fix-pal-speedup: delay video track if needed
[transcoding] / fix-pal-speedup
index 74681c1ff21edfdef5ba6e33c9db08f8916c20d2..5b77d451163c122b638e618f181167fd0f675064 100755 (executable)
@@ -1,36 +1,66 @@
-#!/bin/bash -e
+#!/bin/bash
 
 # Many DVDs released in Australia are sped up from 24fps to 25fps.
 # This script reverses the procedure, correcting the audio pitch.
-# The video framerate is adjusted without re-encoding. The audio is slowed and
-# volume normalised then re-encoded as mp3.
+# The video framerate is adjusted without re-encoding. The audio is
+# slowed, and encoded as AAC, preserving surround sound.
 
 if [ -z "$1" -o -z "$2" ]; then
-    echo "Usage: $0 destdir infile [infile ...]"
+    echo "Usage: $0 infile outfile"
     exit 1
 fi
 
+set -o pipefail -eux
 FORCEFPS="24"
-SLOWDOWN="0.96"
+SLOWFILTER="-filter asetrate=46080,aresample=osr=48000:resampler=soxr"
 
-destdir="$1"
-shift
+function mux_replace_audio {
+    local infile="$1"
+    local audiofile="$2"
+    local outfile="$3"
 
-for infile in "$@"; do
-    outfile="$destdir/$(basename "$infile")"
+    local audiodelay="$(get_minimum_timestamp "$infile" "audio")"
+    local videodelay="$(get_minimum_timestamp "$infile" "video")"
+    local videotrackid="$(get_track_id "$infile" "video")"
 
-    if [ -f "$outfile" ]; then
-        echo "Not overwriting $outfile"
-        continue
-    fi
+    mkvmerge \
+        -o "${outfile}" \
+        --default-duration "${videotrackid}:${FORCEFPS}fps" \
+        --sync "${videotrackid}:$((videodelay / 1000000))" \
+        --no-audio "$infile" \
+        --sync "0:$((audiodelay / 1000000))" \
+        "$audiofile"
+}
 
-    set -x
-    tmpdir="$(mktemp -d "${TMPDIR:-/var/tmp}/pal-XXXXXXXX")"
-    mplayer -novideo -ao pcm:file="${tmpdir}/audio.wav" -vo null "$infile"
-    sox "${tmpdir}/audio.wav" "${tmpdir}/audio-fixed.wav" speed "${SLOWDOWN}" gain -n
-    lame --preset standard "${tmpdir}/audio-fixed.wav" "${tmpdir}/audio.mp3"
-    mkvmerge -o "${outfile}" --default-duration "1:${FORCEFPS}fps" --no-audio "$infile" "${tmpdir}/audio.mp3"
+function get_track_id {
+    mkvmerge -i -F json "$1" | jq -r ".tracks[] | select(.type == \"$2\") | .id"
+}
 
-    rm -rf "$tmpdir"
-done
+function get_minimum_timestamp {
+    mkvmerge -F json -i "$1" | jq -r ".tracks[] | select(.type == \"$2\") | .properties.minimum_timestamp"
+}
 
+function encode_audio {
+    ffmpeg \
+        -i "$1" \
+        -vn \
+        $SLOWFILTER \
+        -c:a libfdk_aac -vbr 3 \
+        "$2"
+}
+
+function convert_file {
+    local infile="$1"
+    local outfile="$2"
+    local audiofile="${tmpdir}/audiofile.m4a"
+
+    encode_audio "$infile" "$audiofile"
+    mux_replace_audio "$infile" "$audiofile" "$outfile"
+}
+
+
+infile="$1"
+outfile="$2"
+tmpdir="$(mktemp -d "${TMPDIR:-/var/tmp}/pal-XXXXXXXX")"
+convert_file "$infile" "$outfile"
+rm -rf "$tmpdir"